<?php
/*
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */

/* å饹 */
class SC_Session {
    var $login_id;		// 桼̾
    var $authority;		// 桼
    var $cert;			// ǧʸ(ǧȽ˻)
    var $sid;			// åID
    var $member_id;		// 桼μ祭
    var $uniqid;         // ڡܤå˻

    /* 󥹥ȥ饯 */
    function SC_Session() {
        // å󳫻
        sfDomainSessionStart();

        // å¸
        if(isset($_SESSION['cert'])) {
            $this->sid = session_id();
            $this->cert = $_SESSION['cert'];
            $this->login_id  = $_SESSION['login_id'];
            $this->authority = $_SESSION['authority'];	// :0, :1, :2
            $this->member_id = $_SESSION['member_id'];
            $this->uniqid    = isset($_SESSION['uniq_id']) ? $_SESSION['uniq_id'] : '';

            // ˵Ͽ
            gfPrintLog("access : user=".$this->login_id." auth=".$this->authority." sid=".$this->sid);
        } else {
            // ˵Ͽ
            gfPrintLog("access error.");
        }
    }
    /* ǧȽ */
    function IsSuccess() {
        global $arrPERMISSION;
        if($this->cert == CERT_STRING) {
            if(isset($arrPERMISSION[$_SERVER['PHP_SELF']])) {
                // ͤʬθ°ʾΤΤǤʤȥǤʤ
                if($arrPERMISSION[$_SERVER['PHP_SELF']] < $this->authority) {
                    return AUTH_ERROR;
                }
            }
            return SUCCESS;
        }

        return ACCESS_ERROR;
    }

    /* åν񤭹 */
    function SetSession($key, $val) {
        $_SESSION[$key] = $val;
    }

    /* åɤ߹ */
    function GetSession($key) {
        return $_SESSION[$key];
    }

    /* åIDμ */
    function GetSID() {
        return $this->sid;
    }

    /** ˡIDμ **/
    function getUniqId() {
        // ˡIDåȤƤʤϥåȤ롣
        if( empty($_SESSION['uniqid']) ) {
            $this->setUniqId();
        }
        return $this->GetSession('uniqid');
    }

    /** ˡIDΥå **/
    function setUniqId() {
        // ͽ¬ʤ褦˥ʸͿ롣
        $this->SetSession('uniqid', sfGetUniqRandomId());
    }

    /* å˴ */
    function EndSession() {
        // ǥեȤϡPHPSESSID
        $sname = session_name();
        // åѿƲ
        $_SESSION = array();
        // åǤˤϥå󥯥å롣
        // Note: åǤʤå˲롣
        if (isset($_COOKIE[$sname])) {
            setcookie($sname, '', time()-42000, '/');
        }
        // ǽŪˡå˲
        session_destroy();
        // ˵Ͽ
        gfPrintLog("logout : user=".$this->login_id." auth=".$this->authority." sid=".$this->sid);
    }

    // ϢåΤ˴롣
    function logout() {
        unset($_SESSION['cert']);
        unset($_SESSION['login_id']);
        unset($_SESSION['authority']);
        unset($_SESSION['member_id']);
        unset($_SESSION['uniqid']);
        // ˵Ͽ
        gfPrintLog("logout : user=".$this->login_id." auth=".$this->authority." sid=".$this->sid);
    }
}
?>
