<?php
/**
 * 
 * @copyright	2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 * @link		http://www.lockon.co.jp/
 *
 */
require_once(DATA_PATH . "include/csv_output.inc");
require_once(DATA_PATH . "module/Request.php");
require_once(DATA_PATH . "lib/slib.php");

/****  *********************************************************************************************/

define("MDL_MOVILINK_ID", 12);
define("MODULE_NAME", "ӥϢȥ⥸塼");

/****  *********************************************************************************************/

function sfInitMovilink() {
	if($_GET['aflkey'] != "") {
		$_SESSION['movilink_aflkey'] = $_GET['aflkey'];
	}
}

/**************************************************************************************************************
 * ؿ̾	sfSetModuleDB
 * 	ɬפʥǡ롣
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfSetModuleDB(){
    global $objQuery;
	$arrVal['status'] = $_POST['status'];
	$arrVal['site_id'] = $_POST['site_id'];
	$sqlval['sub_data'] = serialize($arrVal);	
    $objQuery->update("dtb_module", $sqlval, "module_id = ?", array(MDL_MOVILINK_ID));
}

/**************************************************************************************************************
 * ؿ̾	sfGetModuleDB
 * 	ɬפʥǡ롣
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
// DBǡ
function sfGetModuleDB($module_id = MDL_MOVILINK_ID){
   	$objQuery = new SC_Query();
    $arrVal = array($module_id);
    $arrRet = array();
    $sql = "SELECT 
                sub_data
            FROM dtb_module WHERE module_id = ? " . $where;
    $arrRet = $objQuery->getall($sql, $arrVal);
    return unserialize($arrRet[0]['sub_data']);
}

/**************************************************************************************************************
 * ؿ̾	sfIsMoviLink
 * 	ӥ󥯤ͭǤ뤫ɤ
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
// DBǡ
function sfIsMoviLink(){
	$arrRet = sfGetModuleDB();
	if($arrRet['status'] == '1') 
	{
		return true;	
	}
	return false;
}

/**************************************************************************************************************
 * ؿ̾	sfMakeMoviLinkColumn
 * 	ɬפʥब롣
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfMakeMoviLinkColumn() {
	$objQuery = new SC_Query();
	$arrInsCol[] = array("name" => "movilink_net_percent", "type" => "numeric");
	$arrInsCol[] = array("name" => "movilink_net_fix", "type" => "numeric");
	$arrInsCol[] = array("name" => "movilink_draft_text1", "type" => "text");
	$arrInsCol[] = array("name" => "movilink_draft_text2", "type" => "text");
	$arrInsCol[] = array("name" => "movilink_code1", "type" => "text");
	$arrInsCol[] = array("name" => "movilink_kana", "type" => "text");
	$arrInsCol[] = array("name" => "movilink_price", "type" => "numeric");
	
	foreach($arrInsCol as $key => $val) {
		// ܤ¸ߥå
		if(!sfColumnExists("dtb_products", $val["name"])){
			// ⥸塼IDɲ
			$objQuery->query("alter table dtb_products add " . $val["name"] . " " . $val["type"]);
		}
	}
}

/**************************************************************************************************************
 * ؿ̾	sfSetMoviLinkCSV
 * 	CSVѤΥ쥳ɤꤹ
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfSetMoviLinkCSV() {
	$objQuery = new SC_Query();
	$rank = 0;
	
	$objQuery->delete("dtb_csv", "csv_id = ?", array(CSV_ID_MOVI));
	
	// ǡ
	$arrInsData[]= array("name"=>";ʥ",value=>"movilink_code1");
	$arrInsData[]= array("name"=>"̾",value=>"name");
	$arrInsData[]= array("name"=>"̾(եꥬ)",value=>"movilink_kana");
	$arrInsData[]= array("name"=>"Ψ",value=>"movilink_net_percent");
	$arrInsData[]=array("name"=>"󽷳",value=>"movilink_net_fix");
	$arrInsData[]=array("name"=>"°ƥ",value=>"(SELECT category_name FROM dtb_category as cat WHERE dtb_products.category_id = cat.category_id) AS movilink_category");
	$arrInsData[]=array("name"=>"𥿥 - ƥ1",value=>"movilink_draft_text1");
	$arrInsData[]=array("name"=>"𥿥 - ƥ2",value=>"movilink_draft_text2");
	$arrInsData[]=array("name"=>"𥿥 - ƥ2",value=>"movilink_draft_text2");
	$arrInsData[]=array("name"=>"",value=>"main_comment");
	$arrInsData[]=array("name"=>"ʾܺ",value=>"main_list_comment");
	$arrInsData[]=array("name"=>"ʲ",value=>"movilink_price");
	$arrInsData[]=array("name"=>"url",value=>"product_id as movilink_url");
	$arrInsData[]=array("name"=>"ꥢ̾urldocomo",value=>"'' as movilink_url_j");
	$arrInsData[]=array("name"=>"ꥢ̾urlau",value=>"'' as movilink_url_ez");
	$arrInsData[]=array("name"=>"ꥢ̾urlʥեȥХ󥯥Х",value=>"'' as movilink_url_sb");
	$arrInsData[]=array("name"=>"ʲurl",value=>"main_list_image as movilink_image_url");
	$arrInsData[]=array("name"=>"ʲurl(Х)",value=>"main_list_image as movilink_image_url_mobile");
	$arrInsData[]=array("name"=>"ʲͥurl",value=>"main_list_image as movilink_image_thumbnail_url");
	$arrInsData[]=array("name"=>"ʥߥåΨ",value=>"'' as commission_percent");
	
	// ǡʬ롼
	foreach($arrInsData as $key => $val){
		$sql = "INSERT INTO dtb_csv(csv_id,col,disp_name,rank,create_date,update_date) VALUES (?,?,?,?,now(),now())";
		$arrVal = array(CSV_ID_MOVI, $val["value"], $val["name"], ++$rank);
		$objQuery->query($sql,$arrVal);
	}
	/*
	SELECT
    (SELECT category_name FROM dtb_category as cat WHERE prdcls.category_id = cat.category_id) AS movilink_category
    ,*
FROM
    vw_products_allclass as prdcls
	*/
}


/**************************************************************************************************************
 * ؿ̾	sfGetMovilinkCSVList
 * 	ǤCSVեޥåȤǽϤ
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfGetMovilinkCSVList($array) {
    if (count($array) > 0) {
        foreach($array as $key => $val) {
        	switch($val) {
        	case	'𥿥 - ƥ2':
        		break;
        	default:
        		$val = mb_convert_encoding($val, CHAR_CODE, CHAR_CODE);
            	$line .= "\"".$val."\",";
        		break;
        	}
        }
        $line = ereg_replace(",$", "\n", $line);
    }else{
        return false;
    }
    return $line;
}

/**************************************************************************************************************
 * ؿ̾	sfGetMovilinkCSV
 * 	 CSVϥǡ롣(MOVILINK)
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfGetMovilinkCSV($where, $option, $arrval, $arrOutputCols) {
	global $arrPRODUCTS_CVSCOL;

	$from = "dtb_products";
	$cols = sfGetCommaList($arrOutputCols);
	
	$objQuery = new SC_Query();
	$objQuery->setoption($option);
	
	$list_data = $objQuery->select($cols, $from, $where, $arrval);
	$max = count($list_data);
	
	for($i = 0; $i < $max; $i++) {
		// ƹܤCSVѤѴ롣
		$data .= sfMakeMovilinkCSV($list_data[$i]);	
	}
	return $data;
}

/**************************************************************************************************************
 * ؿ̾	sfMakeMovilinkCSV
 * 	 ƹܤCSVѤѴ롣(MOVILINK)
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfMakeMovilinkCSV($list) {
	global $arrDISP;
	$line = "";
	if(is_array($list)) {
		foreach($list as $key => $val) {
			// ӥѾʥɤϤƤʤϽϤʤ
			if($list['movilink_code1'] != "") {
				$tmp = "";
				$blank_flag = false;
				switch($key) {
				// 𥿥
				case 'movilink_draft_text1':
					$tmp = $list['movilink_draft_text1'] . "\n" . $list['movilink_draft_text2'];
					break;
				case 'movilink_draft_text2':
					$blank_flag = true;				
					break;
				// ʲurl
				case 'movilink_image_url':
				case 'movilink_image_url_mobile':
				case 'movilink_image_thumbnail_url':
					$tmp = SITE_URL . "upload/save_image/" . $val;
					break;
				// url
				case 'movilink_url':
					$tmp = MOBILE_SITE_URL . "products/detail.php?product_id=" . $val;
					break;
				default:
					$tmp = $val;
					break;
				}
				if(!$blank_flag) {
					$tmp = str_replace("\"", "\\\"", $tmp);
					$line .= "\"".$tmp."\",";
				}
			}
		}
		// ʸ","Ѵ
		$line = ereg_replace(",$", "\n", $line);
	}
	return $line;
}

/**************************************************************************************************************
 * ؿ̾	sfConnectMovilinkURL($order_id)
 * 	ӥURL³
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfConnectMovilinkURL($order_id) {
	/*
	 * URLեޥå
	 * 
	 * http://c.moaf.jp/eres/?sid=ECID&aflkey=AFL&uid1=ʸID1&uid2=ʸID2&items=ڸ̾ʥɡ
	 * 
	 */
	
	$objQuery = new SC_Query();
	$col = "(SELECT movilink_code1 FROM dtb_products WHERE dtb_products.product_id = dtb_order_detail.product_id) AS code,
			product_id, 
			quantity, 
			price
	";
	$arrRet = $objQuery->select($col, "dtb_order_detail", "order_id = ?", array($order_id));
	
	$items = "";
	// ̾ʥɤκ
	foreach($arrRet as $key => $val) {
		if($items != "") {
			$items.= ",";
		}
		$items.= $val['code'].";".$val['price']."x".$val['quantity'];
	}
	
	$arrRet = sfGetModuleDB();
	$site_id = $arrRet['site_id'];
	$aflkey = $_SESSION['movilink_aflkey'];
	
	$url = "http://c.moaf.jp/eres/?sid=" . $site_id . "&aflkey=" . $aflkey . "&uid1=" . $order_id . "&items=" . $items;
	
	$req = new HTTP_Request($url);
	
	// GETξ
	$req->setMethod(HTTP_REQUEST_METHOD_GET);
	$ret = $req->sendRequest();
	if (!PEAR::isError($ret)) {
	    $body = $req->getResponseBody();
	    gfPrintLog($body);
	}else{
	    gfPrintLog($ret->getMessage());
	}
}
 

?>